SystemOrganization addCategory: #'SimpleApplescript-Core'!

Object subclass: #Applescript
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleApplescript-Core'!

!Applescript commentStamp: 'SeanDeNigris 12/6/2011 09:55' prior: 0!
I execute Applescript scripts via my class side #doIt:.

I am a bare-bones replacement for the class of the same name in the Applescript project (on Squeaksource) because the required plugin does not work on the new Cocoa Cog VMs.!

!Applescript class methodsFor: 'scripting' stamp: 'SeanDeNigris 3/27/2012 10:07'!
asOldManSay: aString
	"self asOldManSay: 'you damn kids get off my lawn'"

	self doIt: 'say ', aString surroundedByDoubleQuotes, ' using "Bahh"'.! !

!Applescript class methodsFor: 'scripting' stamp: 'SeanDeNigris 3/14/2012 19:23'!
asYoungGirlSay: aString 

	self doIt: 'say ', aString surroundedByDoubleQuotes, ' using "Princess"'.! !

!Applescript class methodsFor: 'scripting' stamp: 'SeanDeNigris 8/6/2012 16:37'!
doIt: aString 

	| output |
	output := OsaScript run: aString.
	^ self smalltalkifyOutput: output.
! !

!Applescript class methodsFor: 'private' stamp: 'SeanDeNigris 1/6/2012 11:38'!
escapeDoubleQuotesIn: aString
	"Should be in String, but this is all very experimental, so I'm keeping it contained"

	^ aString copyReplaceAll: '"' with: '\"' asTokens: false.! !

!Applescript class methodsFor: 'private' stamp: 'SeanDeNigris 2/24/2012 16:19'!
escapeTabsIn: aString 

	^ aString copyWithout: Character tab.! !

!Applescript class methodsFor: 'private' stamp: 'SeanDeNigris 2/24/2012 16:37'!
makeSafeForMultiline: aString

	| tabsEscaped |
	tabsEscaped := self escapeTabsIn: aString.
	^ self escapeDoubleQuotesIn: tabsEscaped.! !

!Applescript class methodsFor: 'private' stamp: 'SeanDeNigris 8/7/2014 14:14'!
processAtom: aString

	| isApplescriptString |
	aString = 'true' ifTrue: [ ^ true ].
	aString = 'false' ifTrue: [ ^ false ].
	(aString beginsWith: 'date ') ifTrue: [ ^ self processDate: aString ].
	isApplescriptString := aString isEmpty not and: [ aString first = $" and: [ aString last = $" ] ].
	isApplescriptString ifTrue: [ ^ self processString: aString ].
	^ ApplescriptReference on: aString.! !

!Applescript class methodsFor: 'private' stamp: 'SeanDeNigris 8/8/2012 10:19'!
processDate: aString 

	| dateString weekdayStripped |
	dateString := aString copyFrom: 7 to: aString size - 1.
	weekdayStripped := dateString copyAfter: Character space.
	^ weekdayStripped asDateAndTime.! !

!Applescript class methodsFor: 'private' stamp: 'SeanDeNigris 8/6/2012 18:32'!
processList: returnString

	| delimiter item contents listParser result listClose |
	delimiter := ', ' asParser.
	listClose := $} asParser.
	item := (delimiter / listClose) negate plus flatten.
	contents := (item separatedBy: delimiter) ==> [ :nodes | nodes reject: [ :n | n = ', ' ] ].
	listParser := ${ asParser, contents optional, listClose ==> #second.
	result := listParser parse: returnString.
	^ result isNil
		ifTrue: [ OrderedCollection new ]
		ifFalse: [ result collect: [ :e | self smalltalkifyOutput: e ] ].! !

!Applescript class methodsFor: 'private' stamp: 'SeanDeNigris 8/8/2012 10:20'!
processRecord: aString 
	'{who:"Matt", town:"Ojai"}'.
	self shouldBeImplemented.! !

!Applescript class methodsFor: 'private' stamp: 'SeanDeNigris 2/24/2013 21:04'!
processString: aString 

	| rawString |
	rawString := self stripQuotesFrom: aString.
	^ rawString copyReplaceAll: '\"' with: '"'.! !

!Applescript class methodsFor: 'scripting' stamp: 'SeanDeNigris 2/16/2012 21:56'!
say: aString 

	self doIt: 'say ', aString surroundedByDoubleQuotes.! !

!Applescript class methodsFor: 'private' stamp: 'SeanDeNigris 8/7/2014 14:14'!
smalltalkifyOutput: aString 

	| isList |
	isList := aString isEmpty not and: [ aString first = ${ and: [ aString last = $} ] ].
	isList ifTrue: [ ^ self processList: aString ].
	^ self processAtom: aString.! !

!Applescript class methodsFor: 'private' stamp: 'SeanDeNigris 8/6/2012 19:07'!
stripQuotesFrom: aStringReturnedFromApplescript

	aStringReturnedFromApplescript ifEmpty: [ ^ aStringReturnedFromApplescript ].
	^ aStringReturnedFromApplescript
		copyFrom: 2
		to: aStringReturnedFromApplescript size - 1.! !

Object subclass: #ApplescriptReference
	instanceVariableNames: 'string'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleApplescript-Core'!

!ApplescriptReference class methodsFor: 'instance creation' stamp: 'SeanDeNigris 8/8/2012 10:08'!
on: aString

	^ self new string: aString.! !

!ApplescriptReference methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 8/8/2012 10:09'!
string: aString

	 string := aString.! !

Object subclass: #OsaScript
	instanceVariableNames: 'recompilableOutput scriptSource'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleApplescript-Core'!

!OsaScript class methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 8/6/2012 16:02'!
run: aString

	| command |
	command := self new
		script: aString;
		recompilableOutput.
	^ command run.! !

!OsaScript methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 8/6/2012 16:13'!
initialize

	super initialize.
	recompilableOutput := false.! !

!OsaScript methodsFor: 'configuration' stamp: 'SeanDeNigris 8/6/2012 16:12'!
recompilableOutput

	recompilableOutput := true.! !

!OsaScript methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 8/6/2012 16:10'!
run

	| process commandTemplate flags commandString |
	commandTemplate := '/usr/bin/osascript {1} <<END_S
{2}
END_S'.
	flags := recompilableOutput
		ifTrue: [ '-ss' ]
		ifFalse: [ '' ].
	commandString := commandTemplate format: { flags. scriptSource }.
	commandString := commandString copyReplaceAll: Character cr asString with: Character lf asString.
	process := PipeableOSProcess waitForCommand: commandString.
	process succeeded ifFalse: [ self error: process errorUpToEndOfFile ].
	process close; closePipes.
	^ process output trimRight.
! !

!OsaScript methodsFor: 'accessing' stamp: 'SeanDeNigris 8/6/2012 16:12'!
script: aString 

	scriptSource := aString.! !
